package com.clx.performance.struct.export;

import com.clx.performance.model.export.ExportField;
import com.clx.performance.model.export.ExtendExportField;
import com.clx.performance.vo.pc.export.ExportFieldVo;
import com.msl.common.utils.DateUtils;
import org.mapstruct.IterableMapping;
import org.mapstruct.Mapper;
import org.mapstruct.Named;

import java.util.List;


//@Mapper(componentModel = "spring", imports = {DateUtils.class, BlendingBaseParam.class, FunctionCodeEnum.class, WhetherEnum.class})
@Mapper(componentModel = "spring", imports = {DateUtils.class})
public interface ExportFieldStruct {

    ExportFieldVo convert(ExportField field);

    @Named("convertExtend")
    ExportFieldVo convertExtend(ExtendExportField field);

    List<ExportFieldVo> convert(List<ExportField> fields);

    @IterableMapping(qualifiedByName = "convertExtend")
    List<ExportFieldVo> convertExtendList(List<ExtendExportField> fields);

//    List<ExtendExportField> convertToFieldList(List<CoalBlendingBase> baseList, @Context BlendingBaseParam param);
//
//    @Mapping(target = "exportFunctionCode", expression = "java(FunctionCodeEnum.COAL_BLENDING.getCode())")
//    @Mapping(target = "code", source = "base.baseId")
//    @Mapping(target = "sort", expression = "java(base.getId() - Integer.MAX_VALUE)")
//    @Mapping(target = "name", source = "base.name")
//    @Mapping(target = "date", expression = "java(DateUtils.parseDate(param.getDate()).orNull())")
//    @Mapping(target = "userNo", expression = "java(param.getOperateUserNo())")
//    @Mapping(target = "companyNo", expression = "java(param.getOperateCompanyNo())")
//    @Mapping(target = "required", expression = "java(WhetherEnum.TRUE.getCode())")
//    ExtendExportField convertToField(CoalBlendingBase base, @Context BlendingBaseParam param);
}
