package com.clx.performance.dao.export;

import com.clx.performance.mapper.export.ExtendExportFieldMapper;
import com.clx.performance.model.export.ExtendExportField;
import com.msl.common.dao.BaseDao;

import java.util.List;


public interface ExtendExportFieldDao extends BaseDao<ExtendExportFieldMapper, ExtendExportField, Integer> {

    /**
     * 根据功能code查询字段
     *
     * @param code      功能code
     * @param companyNo companyNo
     * @return List
     */
    List<ExtendExportField> listFieldByFunctionCode(String code, Long companyNo, String date);

    /**
     * 删除
     *
     * @param code             code
     * @param operateCompanyNo operateCompanyNo
     */
    void delete(String code, Long operateCompanyNo, String date);
}
